<html>
<head>
<title>OgreRenderQueueSortingGrouping.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderQueueSortingGrouping.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderQueueSortingGrouping_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderQueueSortingGrouping_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderQueueSortingGrouping_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreTechnique_8h.html">OgreTechnique.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgrePass_8h.html">OgrePass.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreRadixSort_8h.html">OgreRadixSort.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00051"></a><a class="code" href="structOgre_1_1RenderablePass.html">00051</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>
<a name="l00052"></a>00052     {
<a name="l00054"></a><a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee">00054</a>         <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* <a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>;
<a name="l00056"></a><a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990">00056</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* <a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="structOgre_1_1RenderablePass.html#aced02c6752335dbd5bd4ff1681c35882">00058</a>         <a class="code" href="structOgre_1_1RenderablePass.html#aced02c6752335dbd5bd4ff1681c35882">RenderablePass</a>(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* p) :<a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>(rend), <a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>(p) {}
<a name="l00059"></a>00059     };
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00069"></a><a class="code" href="classOgre_1_1QueuedRenderableVisitor.html">00069</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1QueuedRenderableVisitor.html#aa639df153b7748f890d3d11d64e6a0e8">00072</a>         <a class="code" href="classOgre_1_1QueuedRenderableVisitor.html#aa639df153b7748f890d3d11d64e6a0e8">QueuedRenderableVisitor</a>() {}
<a name="l00073"></a><a class="code" href="classOgre_1_1QueuedRenderableVisitor.html#a9e9fca8d2b7fd4c75a24b6c7f8b1b234">00073</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1QueuedRenderableVisitor.html#a9e9fca8d2b7fd4c75a24b6c7f8b1b234">~QueuedRenderableVisitor</a>() {}
<a name="l00074"></a>00074         
<a name="l00081"></a>00081         <span class="keyword">virtual</span> <span class="keywordtype">void</span> visit(<a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>* rp) = 0;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <span class="comment">/* When visiting a collection grouped by pass, this is</span>
<a name="l00084"></a>00084 <span class="comment">            called when the grouping pass changes.</span>
<a name="l00085"></a>00085 <span class="comment">        @remarks</span>
<a name="l00086"></a>00086 <span class="comment">            If this method is called, the RenderablePass visit </span>
<a name="l00087"></a>00087 <span class="comment">            method will not be called for this collection. The </span>
<a name="l00088"></a>00088 <span class="comment">            Renderable visit method will be called for each item</span>
<a name="l00089"></a>00089 <span class="comment">            underneath the pass grouping level.</span>
<a name="l00090"></a>00090 <span class="comment">        @return True to continue, false to skip the Renderables underneath</span>
<a name="l00091"></a>00091 <span class="comment">        */</span>
<a name="l00092"></a>00092         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> visit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* p) = 0;
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> visit(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* r) = 0;
<a name="l00100"></a>00100         
<a name="l00101"></a>00101         
<a name="l00102"></a>00102     };
<a name="l00103"></a>00103 
<a name="l00113"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html">00113</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderQueueAlloc</a>
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115     <span class="keyword">public</span>:
<a name="l00124"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844">00124</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">OrganisationMode</a>
<a name="l00125"></a>00125         {
<a name="l00127"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844a5cb7861265877a6f1f0a4b3508df7014">00127</a>             OM_PASS_GROUP = 1,
<a name="l00129"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844aaec5c102c9894feda331832a82738d72">00129</a>             OM_SORT_DESCENDING = 2,
<a name="l00133"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844a2cb722796eba6d25f8f7e8d7a4738241">00133</a>             OM_SORT_ASCENDING = 6
<a name="l00134"></a>00134         };
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     <span class="keyword">protected</span>:
<a name="l00138"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html">00138</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html" title="Comparator to order pass groups.">PassGroupLess</a>
<a name="l00139"></a>00139         {
<a name="l00140"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html#a9600b8c32a4c168e3f7f58f8eeeaccd2">00140</a>             <span class="keywordtype">bool</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> operator()(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* a, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* b)<span class="keyword"> const</span>
<a name="l00141"></a>00141 <span class="keyword">            </span>{
<a name="l00142"></a>00142                 <span class="comment">// Sort by passHash, which is pass, then texture unit changes</span>
<a name="l00143"></a>00143                 <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> hasha = a-&gt;<a class="code" href="classOgre_1_1Pass.html#ac653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &#39;hash&#39; of this pass, ie a precomputed number to use for sorting.">getHash</a>();
<a name="l00144"></a>00144                 <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> hashb = b-&gt;<a class="code" href="classOgre_1_1Pass.html#ac653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &#39;hash&#39; of this pass, ie a precomputed number to use for sorting.">getHash</a>();
<a name="l00145"></a>00145                 <span class="keywordflow">if</span> (hasha == hashb)
<a name="l00146"></a>00146                 {
<a name="l00147"></a>00147                     <span class="comment">// Must differentTransparentQueueItemLessiate by pointer incase 2 passes end up with the same hash</span>
<a name="l00148"></a>00148                     <span class="keywordflow">return</span> a &lt; b;
<a name="l00149"></a>00149                 }
<a name="l00150"></a>00150                 <span class="keywordflow">else</span>
<a name="l00151"></a>00151                 {
<a name="l00152"></a>00152                     <span class="keywordflow">return</span> hasha &lt; hashb;
<a name="l00153"></a>00153                 }
<a name="l00154"></a>00154             }
<a name="l00155"></a>00155         };
<a name="l00157"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html">00157</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html" title="Comparator to order objects by descending camera distance.">DepthSortDescendingLess</a>
<a name="l00158"></a>00158         {
<a name="l00159"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#a59ff46e2fa195e05f28518e32c07c7db">00159</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#a59ff46e2fa195e05f28518e32c07c7db">camera</a>;
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#ad7c5f19a708502c538b73c7ee8e3ca1f">00161</a>             <a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html" title="Comparator to order objects by descending camera distance.">DepthSortDescendingLess</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00162"></a>00162                 : camera(cam)
<a name="l00163"></a>00163             {
<a name="l00164"></a>00164             }
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#ae7f6866b54ba54e39ad26d5b706771aa">00166</a>             <span class="keywordtype">bool</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; a, <span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; b)<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword">            </span>{
<a name="l00168"></a>00168                 <span class="keywordflow">if</span> (a.<a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a> == b.<a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>)
<a name="l00169"></a>00169                 {
<a name="l00170"></a>00170                     <span class="comment">// Same renderable, sort by pass hash</span>
<a name="l00171"></a>00171                     <span class="keywordflow">return</span> a.<a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>-&gt;<a class="code" href="classOgre_1_1Pass.html#ac653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &#39;hash&#39; of this pass, ie a precomputed number to use for sorting.">getHash</a>() &lt; b.<a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>-&gt;<a class="code" href="classOgre_1_1Pass.html#ac653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &#39;hash&#39; of this pass, ie a precomputed number to use for sorting.">getHash</a>();
<a name="l00172"></a>00172                 }
<a name="l00173"></a>00173                 <span class="keywordflow">else</span>
<a name="l00174"></a>00174                 {
<a name="l00175"></a>00175                     <span class="comment">// Different renderables, sort by depth</span>
<a name="l00176"></a>00176                     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> adepth = a.<a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>-&gt;<a class="code" href="classOgre_1_1Renderable.html#a32353addc2f1d02512314b5d1a53c5c1" title="Returns the camera-relative squared depth of this renderable.">getSquaredViewDepth</a>(camera);
<a name="l00177"></a>00177                     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bdepth = b.<a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>-&gt;<a class="code" href="classOgre_1_1Renderable.html#a32353addc2f1d02512314b5d1a53c5c1" title="Returns the camera-relative squared depth of this renderable.">getSquaredViewDepth</a>(camera);
<a name="l00178"></a>00178                     <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(adepth, bdepth))
<a name="l00179"></a>00179                     {
<a name="l00180"></a>00180                         <span class="comment">// Must return deterministic result, doesn&#39;t matter what</span>
<a name="l00181"></a>00181                         <span class="keywordflow">return</span> a.<a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a> &lt; b.<a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>;
<a name="l00182"></a>00182                     }
<a name="l00183"></a>00183                     <span class="keywordflow">else</span>
<a name="l00184"></a>00184                     {
<a name="l00185"></a>00185                         <span class="comment">// Sort DESCENDING by depth (i.e. far objects first)</span>
<a name="l00186"></a>00186                         <span class="keywordflow">return</span> (adepth &gt; bdepth);
<a name="l00187"></a>00187                     }
<a name="l00188"></a>00188                 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190             }
<a name="l00191"></a>00191         };
<a name="l00192"></a>00192 
<a name="l00196"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a9239441cc0c454430284015703858880">00196</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderablePass&gt;::type</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a9239441cc0c454430284015703858880" title="Vector of RenderablePass objects, this is built on the assumption that vectors only ever increase in ...">RenderablePassList</a>;
<a name="l00197"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a77c306b4e66120b36a90c5f937ab6364">00197</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;Renderable*&gt;::type</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a77c306b4e66120b36a90c5f937ab6364">RenderableList</a>;
<a name="l00199"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ac86585dfee248854cbd3d84dbe3f36e5">00199</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;Pass*, RenderableList*, PassGroupLess&gt;::type</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ac86585dfee248854cbd3d84dbe3f36e5" title="Map of pass to renderable lists, this is a grouping by pass.">PassGroupRenderableMap</a>;
<a name="l00200"></a>00200 
<a name="l00202"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html">00202</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html" title="Functor for accessing sort value 1 for radix sort (Pass)">RadixSortFunctorPass</a>
<a name="l00203"></a>00203         {
<a name="l00204"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html#ab22672c70231fc47358363b432009b12">00204</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; p)<span class="keyword"> const</span>
<a name="l00205"></a>00205 <span class="keyword">            </span>{
<a name="l00206"></a>00206                 <span class="keywordflow">return</span> p.<a class="code" href="structOgre_1_1RenderablePass.html#aec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>-&gt;<a class="code" href="classOgre_1_1Pass.html#ac653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &#39;hash&#39; of this pass, ie a precomputed number to use for sorting.">getHash</a>();
<a name="l00207"></a>00207             }
<a name="l00208"></a>00208         };
<a name="l00209"></a>00209 
<a name="l00211"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a760cf336631fb24e6f6cc2fb45c850a1">00211</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RadixSort.html">RadixSort&lt;RenderablePassList, RenderablePass, uint32&gt;</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a760cf336631fb24e6f6cc2fb45c850a1" title="Radix sorter for accessing sort value 1 (Pass)">msRadixSorter1</a>;
<a name="l00212"></a>00212 
<a name="l00214"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html">00214</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html" title="Functor for descending sort value 2 for radix sort (distance)">RadixSortFunctorDistance</a>
<a name="l00215"></a>00215         {
<a name="l00216"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#aebb10cc09cd68a0150517507e71a2b66">00216</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#aebb10cc09cd68a0150517507e71a2b66">camera</a>;
<a name="l00217"></a>00217 
<a name="l00218"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#a3127f7533114a2b5887532f4c207afec">00218</a>             <a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html" title="Functor for descending sort value 2 for radix sort (distance)">RadixSortFunctorDistance</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00219"></a>00219                 : camera(cam)
<a name="l00220"></a>00220             {
<a name="l00221"></a>00221             }
<a name="l00222"></a>00222 
<a name="l00223"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#adc57cb46c570fb3e0dd3d1b6089dd6cf">00223</a>             <span class="keywordtype">float</span> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; p)<span class="keyword"> const</span>
<a name="l00224"></a>00224 <span class="keyword">            </span>{
<a name="l00225"></a>00225                 <span class="comment">// Sort DESCENDING by depth (ie far objects first), use negative distance</span>
<a name="l00226"></a>00226                 <span class="comment">// here because radix sorter always dealing with accessing sort</span>
<a name="l00227"></a>00227                 <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(- p.<a class="code" href="structOgre_1_1RenderablePass.html#a88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>-&gt;<a class="code" href="classOgre_1_1Renderable.html#a32353addc2f1d02512314b5d1a53c5c1" title="Returns the camera-relative squared depth of this renderable.">getSquaredViewDepth</a>(camera));
<a name="l00228"></a>00228             }
<a name="l00229"></a>00229         };
<a name="l00230"></a>00230 
<a name="l00232"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ac4c356244366d78dccbc80a3125c4d36">00232</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RadixSort.html">RadixSort&lt;RenderablePassList, RenderablePass, float&gt;</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ac4c356244366d78dccbc80a3125c4d36" title="Radix sorter for sort value 2 (distance)">msRadixSorter2</a>;
<a name="l00233"></a>00233 
<a name="l00235"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ae9a31d2cd0e88ce11ba006d04cb7ac0d">00235</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ae9a31d2cd0e88ce11ba006d04cb7ac0d" title="Bitmask of the organisation modes requested.">mOrganisationMode</a>;
<a name="l00236"></a>00236 
<a name="l00238"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a3b34af9f4be41db1386d479720ce602e">00238</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ac86585dfee248854cbd3d84dbe3f36e5" title="Map of pass to renderable lists, this is a grouping by pass.">PassGroupRenderableMap</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a3b34af9f4be41db1386d479720ce602e" title="Grouped.">mGrouped</a>;
<a name="l00240"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab800c1e93b112978e82e22f00046e3d1">00240</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a9239441cc0c454430284015703858880" title="Vector of RenderablePass objects, this is built on the assumption that vectors only ever increase in ...">RenderablePassList</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab800c1e93b112978e82e22f00046e3d1" title="Sorted descending (can iterate backwards to get ascending)">mSortedDescending</a>;
<a name="l00241"></a>00241 
<a name="l00243"></a>00243         <span class="keywordtype">void</span> acceptVisitorGrouped(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor) <span class="keyword">const</span>;
<a name="l00245"></a>00245         <span class="keywordtype">void</span> acceptVisitorDescending(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor) <span class="keyword">const</span>;
<a name="l00247"></a>00247         <span class="keywordtype">void</span> acceptVisitorAscending(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor) <span class="keyword">const</span>;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249     <span class="keyword">public</span>:
<a name="l00250"></a>00250         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>();
<a name="l00251"></a>00251         ~<a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>();
<a name="l00252"></a>00252 
<a name="l00254"></a>00254         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00255"></a>00255 
<a name="l00261"></a>00261         <span class="keywordtype">void</span> removePassGroup(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* p);
<a name="l00262"></a>00262         
<a name="l00268"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#afde7f8e139270c04158880ea90da71a0">00268</a>         <span class="keywordtype">void</span> resetOrganisationModes(<span class="keywordtype">void</span>) 
<a name="l00269"></a>00269         { 
<a name="l00270"></a>00270             mOrganisationMode = 0; 
<a name="l00271"></a>00271         }
<a name="l00272"></a>00272         
<a name="l00278"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#a1f30f771db3b5dd9f520a3e17ff9e1bb">00278</a>         <span class="keywordtype">void</span> addOrganisationMode(<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">OrganisationMode</a> om) 
<a name="l00279"></a>00279         { 
<a name="l00280"></a>00280             mOrganisationMode |= om; 
<a name="l00281"></a>00281         }
<a name="l00282"></a>00282 
<a name="l00284"></a>00284         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00285"></a>00285         
<a name="l00289"></a>00289         <span class="keywordtype">void</span> sort(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00290"></a>00290 
<a name="l00297"></a>00297         <span class="keywordtype">void</span> acceptVisitor(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor, OrganisationMode om) <span class="keyword">const</span>;
<a name="l00298"></a>00298 
<a name="l00301"></a>00301         <span class="keywordtype">void</span> merge( <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; rhs );
<a name="l00302"></a>00302     };
<a name="l00303"></a>00303 
<a name="l00323"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html">00323</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderQueueAlloc</a>
<a name="l00324"></a>00324     {
<a name="l00325"></a>00325     <span class="keyword">protected</span>:
<a name="l00326"></a>00326 
<a name="l00328"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#afa964877920d284c972b4684c54fe273">00328</a>         <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* <a class="code" href="classOgre_1_1RenderPriorityGroup.html#afa964877920d284c972b4684c54fe273" title="Parent queue group.">mParent</a>;
<a name="l00329"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#af98ab3bc78759bb0f6fe921d95681c55">00329</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#af98ab3bc78759bb0f6fe921d95681c55">mSplitPassesByLightingType</a>;
<a name="l00330"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a6cb0571ecf3cb5199d95e4ff056499ff">00330</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#a6cb0571ecf3cb5199d95e4ff056499ff">mSplitNoShadowPasses</a>;
<a name="l00331"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#aa978e09317bbe8cf1062b4157510ea65">00331</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#aa978e09317bbe8cf1062b4157510ea65">mShadowCastersNotReceivers</a>;
<a name="l00333"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#ab8560ed065a3001ee34d6fbc46de5527">00333</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#ab8560ed065a3001ee34d6fbc46de5527" title="Solid pass list, used when no shadows, modulative shadows, or ambient passes for additive.">mSolidsBasic</a>;
<a name="l00335"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a56ebcce57f1603250d9b6018b06e98d3">00335</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#a56ebcce57f1603250d9b6018b06e98d3" title="Solid per-light pass list, used with additive shadows.">mSolidsDiffuseSpecular</a>;
<a name="l00337"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#aed4224f5234e3706795dfc4fa16159ed">00337</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#aed4224f5234e3706795dfc4fa16159ed" title="Solid decal (texture) pass list, used with additive shadows.">mSolidsDecal</a>;
<a name="l00339"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#adc851b6c07b963d53f2aedd53dda0b45">00339</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#adc851b6c07b963d53f2aedd53dda0b45" title="Solid pass list, used when shadows are enabled but shadow receive is turned off for these passes...">mSolidsNoShadowReceive</a>;
<a name="l00341"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a61fb215cff04c9d686a2119ccdcc9b4f">00341</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#a61fb215cff04c9d686a2119ccdcc9b4f" title="Unsorted transparent list.">mTransparentsUnsorted</a>;
<a name="l00343"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#acacd2f33af2aceae1bc5775c4457d7da">00343</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html#acacd2f33af2aceae1bc5775c4457d7da" title="Transparent list.">mTransparents</a>;
<a name="l00344"></a>00344 
<a name="l00346"></a>00346         <span class="keywordtype">void</span> removePassEntry(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* p);
<a name="l00347"></a>00347 
<a name="l00349"></a>00349         <span class="keywordtype">void</span> addSolidRenderable(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <span class="keywordtype">bool</span> toNoShadowMap);
<a name="l00351"></a>00351         <span class="keywordtype">void</span> addSolidRenderableSplitByLightType(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00353"></a>00353         <span class="keywordtype">void</span> addUnsortedTransparentRenderable(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00355"></a>00355         <span class="keywordtype">void</span> addTransparentRenderable(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00356"></a>00356 
<a name="l00357"></a>00357     <span class="keyword">public</span>:
<a name="l00358"></a>00358         <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>(<a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* parent, 
<a name="l00359"></a>00359             <span class="keywordtype">bool</span> splitPassesByLightingType,
<a name="l00360"></a>00360             <span class="keywordtype">bool</span> splitNoShadowPasses, 
<a name="l00361"></a>00361             <span class="keywordtype">bool</span> shadowCastersNotReceivers); 
<a name="l00362"></a>00362            
<a name="l00363"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a0a18c4c1f2c29571f606cbac7861c3a9">00363</a>         <a class="code" href="classOgre_1_1RenderPriorityGroup.html#a0a18c4c1f2c29571f606cbac7861c3a9">~RenderPriorityGroup</a>() { }
<a name="l00364"></a>00364 
<a name="l00369"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a1d55ed0d465b381303fd4b0c2e7646a2">00369</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsBasic(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00370"></a>00370 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsBasic; }
<a name="l00373"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a327e07de0d0136a5e489a44e3982b8a4">00373</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsDiffuseSpecular(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00374"></a>00374 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsDiffuseSpecular; }
<a name="l00377"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a745936859235b031c2399a5b3c45df4e">00377</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsDecal(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00378"></a>00378 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsDecal; }
<a name="l00381"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#af5e28105a6ca20ed978cf206f9406e4d">00381</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsNoShadowReceive(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00382"></a>00382 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsNoShadowReceive; }
<a name="l00384"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a6884d6e8d6173190ae3fc833ccdc8d0d">00384</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getTransparentsUnsorted(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00385"></a>00385 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mTransparentsUnsorted; }
<a name="l00387"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#afd96c5fa208a0cabd16b8d6558425e62">00387</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getTransparents(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00388"></a>00388 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mTransparents; }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00397"></a>00397         <span class="keywordtype">void</span> resetOrganisationModes(<span class="keywordtype">void</span>);
<a name="l00398"></a>00398         
<a name="l00405"></a>00405         <span class="keywordtype">void</span> addOrganisationMode(<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> om); 
<a name="l00406"></a>00406 
<a name="l00413"></a>00413         <span class="keywordtype">void</span> defaultOrganisationMode(<span class="keywordtype">void</span>); 
<a name="l00414"></a>00414 
<a name="l00416"></a>00416         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech);
<a name="l00417"></a>00417 
<a name="l00420"></a>00420         <span class="keywordtype">void</span> sort(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00421"></a>00421 
<a name="l00424"></a>00424         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00425"></a>00425 
<a name="l00429"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a17541d778d6d971eb7ecc0141ca7bbce">00429</a>         <span class="keywordtype">void</span> setSplitPassesByLightingType(<span class="keywordtype">bool</span> split)
<a name="l00430"></a>00430         {
<a name="l00431"></a>00431             mSplitPassesByLightingType = split;
<a name="l00432"></a>00432         }
<a name="l00433"></a>00433 
<a name="l00437"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a82ce83d78ddac522340a9bb9dfd4aa76">00437</a>         <span class="keywordtype">void</span> setSplitNoShadowPasses(<span class="keywordtype">bool</span> split)
<a name="l00438"></a>00438         {
<a name="l00439"></a>00439             mSplitNoShadowPasses = split;
<a name="l00440"></a>00440         }
<a name="l00441"></a>00441 
<a name="l00445"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#ad00485a29818222dffa8b4b42748c57f">00445</a>         <span class="keywordtype">void</span> setShadowCastersCannotBeReceivers(<span class="keywordtype">bool</span> ind)
<a name="l00446"></a>00446         {
<a name="l00447"></a>00447             mShadowCastersNotReceivers = ind;
<a name="l00448"></a>00448         }
<a name="l00449"></a>00449 
<a name="l00452"></a>00452         <span class="keywordtype">void</span> merge( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>* rhs );
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 
<a name="l00455"></a>00455     };
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00465"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html">00465</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderQueueAlloc</a>
<a name="l00466"></a>00466     {
<a name="l00467"></a>00467     <span class="keyword">public</span>:
<a name="l00468"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a667e088e296591cd43e9acdc5daadc80">00468</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;ushort, RenderPriorityGroup*, std::less&lt;ushort&gt;</a> &gt;::type <a class="code" href="classOgre_1_1RenderQueueGroup.html#a667e088e296591cd43e9acdc5daadc80">PriorityMap</a>;
<a name="l00469"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a38216d5a4828871b53e5fbecdc8d4984">00469</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;PriorityMap&gt;</a> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a38216d5a4828871b53e5fbecdc8d4984">PriorityMapIterator</a>;
<a name="l00470"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a34dffe13210b7f61932a25fc042f404f">00470</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;PriorityMap&gt;</a> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a34dffe13210b7f61932a25fc042f404f">ConstPriorityMapIterator</a>;
<a name="l00471"></a>00471     <span class="keyword">protected</span>:
<a name="l00472"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#af9f686713ffc4826d877050b9eeb7269">00472</a>         <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* <a class="code" href="classOgre_1_1RenderQueueGroup.html#af9f686713ffc4826d877050b9eeb7269">mParent</a>;
<a name="l00473"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a6ea0e9f15de8415698537ebab761b941">00473</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a6ea0e9f15de8415698537ebab761b941">mSplitPassesByLightingType</a>;
<a name="l00474"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a512ffe61ae9cf4871096a547d500a3c9">00474</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a512ffe61ae9cf4871096a547d500a3c9">mSplitNoShadowPasses</a>;
<a name="l00475"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#acb8f17ce35fe836bbcc33e4549d501e0">00475</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html#acb8f17ce35fe836bbcc33e4549d501e0">mShadowCastersNotReceivers</a>;
<a name="l00477"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a89c61e07d1956e97cf067aaf9657bc31">00477</a>         <a class="code" href="classOgre_1_1RenderQueueGroup.html#a667e088e296591cd43e9acdc5daadc80">PriorityMap</a> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a89c61e07d1956e97cf067aaf9657bc31" title="Map of RenderPriorityGroup objects.">mPriorityGroups</a>;
<a name="l00479"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a5c4eaacfc8c686034b7795580f748f89">00479</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a5c4eaacfc8c686034b7795580f748f89" title="Whether shadows are enabled for this queue.">mShadowsEnabled</a>;
<a name="l00481"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a98e8d6250115823a41a02e579509fb2b">00481</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a98e8d6250115823a41a02e579509fb2b" title="Bitmask of the organisation modes requested (for new priority groups)">mOrganisationMode</a>;
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484     <span class="keyword">public</span>:
<a name="l00485"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#aa8f83bb601e8344a255fc2aafbc958ee">00485</a>         <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* parent,
<a name="l00486"></a>00486             <span class="keywordtype">bool</span> splitPassesByLightingType,
<a name="l00487"></a>00487             <span class="keywordtype">bool</span> splitNoShadowPasses,
<a name="l00488"></a>00488             <span class="keywordtype">bool</span> shadowCastersNotReceivers) 
<a name="l00489"></a>00489             : mParent(parent)
<a name="l00490"></a>00490             , mSplitPassesByLightingType(splitPassesByLightingType)
<a name="l00491"></a>00491             , mSplitNoShadowPasses(splitNoShadowPasses)
<a name="l00492"></a>00492             , mShadowCastersNotReceivers(shadowCastersNotReceivers)
<a name="l00493"></a>00493             , mShadowsEnabled(true)
<a name="l00494"></a>00494             , mOrganisationMode(0)
<a name="l00495"></a>00495         {
<a name="l00496"></a>00496         }
<a name="l00497"></a>00497 
<a name="l00498"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#ac12bd8451907d485889812b0a6b6ceca">00498</a>         <a class="code" href="classOgre_1_1RenderQueueGroup.html#ac12bd8451907d485889812b0a6b6ceca">~RenderQueueGroup</a>() {
<a name="l00499"></a>00499             <span class="comment">// destroy contents now</span>
<a name="l00500"></a>00500             PriorityMap::iterator i;
<a name="l00501"></a>00501             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != mPriorityGroups.end(); ++i)
<a name="l00502"></a>00502             {
<a name="l00503"></a>00503                 <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> i-&gt;second;
<a name="l00504"></a>00504             }
<a name="l00505"></a>00505         }
<a name="l00506"></a>00506 
<a name="l00508"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a9225e3493596e1701e583721d1846f24">00508</a>         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">PriorityMapIterator</a> getIterator(<span class="keywordtype">void</span>)
<a name="l00509"></a>00509         {
<a name="l00510"></a>00510             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">PriorityMapIterator</a>(mPriorityGroups.begin(), mPriorityGroups.end());
<a name="l00511"></a>00511         }
<a name="l00512"></a>00512 
<a name="l00514"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a25f29c808539ac74609265b3bc999192">00514</a>         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstPriorityMapIterator</a> getIterator(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00515"></a>00515 <span class="keyword">        </span>{
<a name="l00516"></a>00516             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstPriorityMapIterator</a>(mPriorityGroups.begin(), mPriorityGroups.end());
<a name="l00517"></a>00517         }
<a name="l00518"></a>00518 
<a name="l00520"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a0bd953e5e30d631542ef7d85158b017e">00520</a>         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> priority)
<a name="l00521"></a>00521         {
<a name="l00522"></a>00522             <span class="comment">// Check if priority group is there</span>
<a name="l00523"></a>00523             PriorityMap::iterator i = mPriorityGroups.find(priority);
<a name="l00524"></a>00524             <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>* pPriorityGrp;
<a name="l00525"></a>00525             <span class="keywordflow">if</span> (i == mPriorityGroups.end())
<a name="l00526"></a>00526             {
<a name="l00527"></a>00527                 <span class="comment">// Missing, create</span>
<a name="l00528"></a>00528                 pPriorityGrp = <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>(<span class="keyword">this</span>, 
<a name="l00529"></a>00529                     mSplitPassesByLightingType,
<a name="l00530"></a>00530                     mSplitNoShadowPasses, 
<a name="l00531"></a>00531                     mShadowCastersNotReceivers);
<a name="l00532"></a>00532                 <span class="keywordflow">if</span> (mOrganisationMode)
<a name="l00533"></a>00533                 {
<a name="l00534"></a>00534                     pPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#afac98cbfa333ffbbd6f92a2dede71d83" title="Reset the organisation modes required for the solids in this group.">resetOrganisationModes</a>();
<a name="l00535"></a>00535                     pPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#ae1fbc62e9014f3e36bef8f7f638ccf19" title="Add a required sorting / grouping mode for the solids in this group.">addOrganisationMode</a>((<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a>)mOrganisationMode);
<a name="l00536"></a>00536                 }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538                 mPriorityGroups.insert(PriorityMap::value_type(priority, pPriorityGrp));
<a name="l00539"></a>00539             }
<a name="l00540"></a>00540             <span class="keywordflow">else</span>
<a name="l00541"></a>00541             {
<a name="l00542"></a>00542                 pPriorityGrp = i-&gt;second;
<a name="l00543"></a>00543             }
<a name="l00544"></a>00544 
<a name="l00545"></a>00545             <span class="comment">// Add</span>
<a name="l00546"></a>00546             pPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#ab09fd661aa02509a1e4f83b18f5da74f" title="Add a renderable to this group.">addRenderable</a>(pRend, pTech);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548         }
<a name="l00549"></a>00549 
<a name="l00557"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#aeeaaf69657b5425e8f294466f0061a41">00557</a>         <span class="keywordtype">void</span> clear(<span class="keywordtype">bool</span> destroy = <span class="keyword">false</span>)
<a name="l00558"></a>00558         {
<a name="l00559"></a>00559             PriorityMap::iterator i, iend;
<a name="l00560"></a>00560             iend = mPriorityGroups.end();
<a name="l00561"></a>00561             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00562"></a>00562             {
<a name="l00563"></a>00563                 <span class="keywordflow">if</span> (destroy)
<a name="l00564"></a>00564                     <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> i-&gt;second;
<a name="l00565"></a>00565                 <span class="keywordflow">else</span>
<a name="l00566"></a>00566                     i-&gt;second-&gt;clear();
<a name="l00567"></a>00567             }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569             <span class="keywordflow">if</span> (destroy)
<a name="l00570"></a>00570                 mPriorityGroups.clear();
<a name="l00571"></a>00571 
<a name="l00572"></a>00572         }
<a name="l00573"></a>00573 
<a name="l00586"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a180a462bafa9b9d472a59d044657e6ef">00586</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a180a462bafa9b9d472a59d044657e6ef" title="Indicate whether a given queue group will be doing any shadow setup.">setShadowsEnabled</a>(<span class="keywordtype">bool</span> enabled) { mShadowsEnabled = enabled; }
<a name="l00587"></a>00587 
<a name="l00589"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a1494737d903b3e54f3b1694874c2c034">00589</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html#a1494737d903b3e54f3b1694874c2c034" title="Are shadows enabled for this queue?">getShadowsEnabled</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowsEnabled; }
<a name="l00590"></a>00590 
<a name="l00594"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#aa9136681bf8704ada4af84f2c30be7b3">00594</a>         <span class="keywordtype">void</span> setSplitPassesByLightingType(<span class="keywordtype">bool</span> split)
<a name="l00595"></a>00595         {
<a name="l00596"></a>00596             mSplitPassesByLightingType = split;
<a name="l00597"></a>00597             PriorityMap::iterator i, iend;
<a name="l00598"></a>00598             iend = mPriorityGroups.end();
<a name="l00599"></a>00599             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00600"></a>00600             {
<a name="l00601"></a>00601                 i-&gt;second-&gt;setSplitPassesByLightingType(split);
<a name="l00602"></a>00602             }
<a name="l00603"></a>00603         }
<a name="l00608"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a9d53fac5486bb4379965858840900263">00608</a>         <span class="keywordtype">void</span> setSplitNoShadowPasses(<span class="keywordtype">bool</span> split)
<a name="l00609"></a>00609         {
<a name="l00610"></a>00610             mSplitNoShadowPasses = split;
<a name="l00611"></a>00611             PriorityMap::iterator i, iend;
<a name="l00612"></a>00612             iend = mPriorityGroups.end();
<a name="l00613"></a>00613             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00614"></a>00614             {
<a name="l00615"></a>00615                 i-&gt;second-&gt;setSplitNoShadowPasses(split);
<a name="l00616"></a>00616             }
<a name="l00617"></a>00617         }
<a name="l00621"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a5c2e2f614fe51fb1e6954b28f4c3a366">00621</a>         <span class="keywordtype">void</span> setShadowCastersCannotBeReceivers(<span class="keywordtype">bool</span> ind)
<a name="l00622"></a>00622         {
<a name="l00623"></a>00623             mShadowCastersNotReceivers = ind;
<a name="l00624"></a>00624             PriorityMap::iterator i, iend;
<a name="l00625"></a>00625             iend = mPriorityGroups.end();
<a name="l00626"></a>00626             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00627"></a>00627             {
<a name="l00628"></a>00628                 i-&gt;second-&gt;setShadowCastersCannotBeReceivers(ind);
<a name="l00629"></a>00629             }
<a name="l00630"></a>00630         }
<a name="l00637"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a4fcd2c524232e0708786959bf74fe153">00637</a>         <span class="keywordtype">void</span> resetOrganisationModes(<span class="keywordtype">void</span>)
<a name="l00638"></a>00638         {
<a name="l00639"></a>00639             mOrganisationMode = 0;
<a name="l00640"></a>00640 
<a name="l00641"></a>00641             PriorityMap::iterator i, iend;
<a name="l00642"></a>00642             iend = mPriorityGroups.end();
<a name="l00643"></a>00643             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00644"></a>00644             {
<a name="l00645"></a>00645                 i-&gt;second-&gt;resetOrganisationModes();
<a name="l00646"></a>00646             }
<a name="l00647"></a>00647         }
<a name="l00648"></a>00648         
<a name="l00655"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a195e1d749ca78952f9e4c222d6a536c3">00655</a>         <span class="keywordtype">void</span> addOrganisationMode(<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> om)
<a name="l00656"></a>00656         {
<a name="l00657"></a>00657             mOrganisationMode |= om;
<a name="l00658"></a>00658 
<a name="l00659"></a>00659             PriorityMap::iterator i, iend;
<a name="l00660"></a>00660             iend = mPriorityGroups.end();
<a name="l00661"></a>00661             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00662"></a>00662             {
<a name="l00663"></a>00663                 i-&gt;second-&gt;addOrganisationMode(om);
<a name="l00664"></a>00664             }
<a name="l00665"></a>00665         }
<a name="l00666"></a>00666 
<a name="l00673"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a0cf70d2d850ef3746957b337b1bba4d0">00673</a>         <span class="keywordtype">void</span> defaultOrganisationMode(<span class="keywordtype">void</span>)
<a name="l00674"></a>00674         {
<a name="l00675"></a>00675             mOrganisationMode = 0;
<a name="l00676"></a>00676 
<a name="l00677"></a>00677             PriorityMap::iterator i, iend;
<a name="l00678"></a>00678             iend = mPriorityGroups.end();
<a name="l00679"></a>00679             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00680"></a>00680             {
<a name="l00681"></a>00681                 i-&gt;second-&gt;defaultOrganisationMode();
<a name="l00682"></a>00682             }
<a name="l00683"></a>00683         }
<a name="l00684"></a>00684 
<a name="l00687"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a4eb48a76b7a69ed248578d6743f8e9b3">00687</a>         <span class="keywordtype">void</span> merge( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* rhs )
<a name="l00688"></a>00688         {
<a name="l00689"></a>00689             <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstPriorityMapIterator</a> it = rhs-&gt;<a class="code" href="classOgre_1_1RenderQueueGroup.html#a9225e3493596e1701e583721d1846f24" title="Get an iterator for browsing through child contents.">getIterator</a>();
<a name="l00690"></a>00690 
<a name="l00691"></a>00691             <span class="keywordflow">while</span>( it.<a class="code" href="classOgre_1_1IteratorWrapper.html#a468ebc8ca34585ed3ef17a432ee22704" title="Returns true if there are more items in the collection.">hasMoreElements</a>() )
<a name="l00692"></a>00692             {
<a name="l00693"></a>00693                 <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> priority = it.<a class="code" href="classOgre_1_1MapIteratorWrapper.html#a0d526f75afc53f81358876237927bf54" title="Returns the next(=current) key element in the collection, without advancing to the next...">peekNextKey</a>();
<a name="l00694"></a>00694                 <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>* pSrcPriorityGrp = it.<a class="code" href="classOgre_1_1MapIteratorWrapper.html#a2bef2d340ae00274856261b3ad3dcdbc" title="Returns the next(=current) value element in the collection, and advances to the next.">getNext</a>();
<a name="l00695"></a>00695                 <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>* pDstPriorityGrp;
<a name="l00696"></a>00696 
<a name="l00697"></a>00697                 <span class="comment">// Check if priority group is there</span>
<a name="l00698"></a>00698                 PriorityMap::iterator i = mPriorityGroups.find(priority);
<a name="l00699"></a>00699                 <span class="keywordflow">if</span> (i == mPriorityGroups.end())
<a name="l00700"></a>00700                 {
<a name="l00701"></a>00701                     <span class="comment">// Missing, create</span>
<a name="l00702"></a>00702                     pDstPriorityGrp = <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>(<span class="keyword">this</span>, 
<a name="l00703"></a>00703                         mSplitPassesByLightingType,
<a name="l00704"></a>00704                         mSplitNoShadowPasses, 
<a name="l00705"></a>00705                         mShadowCastersNotReceivers);
<a name="l00706"></a>00706                     <span class="keywordflow">if</span> (mOrganisationMode)
<a name="l00707"></a>00707                     {
<a name="l00708"></a>00708                         pDstPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#afac98cbfa333ffbbd6f92a2dede71d83" title="Reset the organisation modes required for the solids in this group.">resetOrganisationModes</a>();
<a name="l00709"></a>00709                         pDstPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#ae1fbc62e9014f3e36bef8f7f638ccf19" title="Add a required sorting / grouping mode for the solids in this group.">addOrganisationMode</a>((<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a>)mOrganisationMode);
<a name="l00710"></a>00710                     }
<a name="l00711"></a>00711 
<a name="l00712"></a>00712                     mPriorityGroups.insert(PriorityMap::value_type(priority, pDstPriorityGrp));
<a name="l00713"></a>00713                 }
<a name="l00714"></a>00714                 <span class="keywordflow">else</span>
<a name="l00715"></a>00715                 {
<a name="l00716"></a>00716                     pDstPriorityGrp = i-&gt;second;
<a name="l00717"></a>00717                 }
<a name="l00718"></a>00718 
<a name="l00719"></a>00719                 <span class="comment">// merge</span>
<a name="l00720"></a>00720                 pDstPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#add2b573cd06af88231226779fba49e6b" title="Merge group of renderables.">merge</a>( pSrcPriorityGrp );
<a name="l00721"></a>00721             }
<a name="l00722"></a>00722         }
<a name="l00723"></a>00723     };
<a name="l00724"></a>00724 
<a name="l00729"></a>00729 }
<a name="l00730"></a>00730 
<a name="l00731"></a>00731 <span class="preprocessor">#endif</span>
<a name="l00732"></a>00732 <span class="preprocessor"></span>
<a name="l00733"></a>00733 
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
